## lomiri-url-dispatcher 0.1.0

=== CMakeLists.txt ===
project(lomiri-url-dispatcher C CXX)
cmake_minimum_required(VERSION 2.8.9)

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lowercase but sometimes they are not.

if ("${cmake_build_type_lower}" STREQUAL "debug")
  option (werror "Treat warnings as errors." FALSE)
else()
  option (werror "Treat warnings as errors." TRUE)
endif()

enable_testing ()
option (enable_lcov "Generate Coverage Reports" ON)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")

set(PACKAGE ${CMAKE_PROJECT_NAME})
set(GETTEXT_PACKAGE ${CMAKE_PROJECT_NAME})

find_package(PkgConfig REQUIRED)
find_package(GDbus)
include(GNUInstallDirs)
include(CheckIncludeFile)
include(CheckFunctionExists)
include(UseGlibGeneration)
include(UseConstantBuilder)

# Workaround for libexecdir on debian
if (EXISTS "/etc/debian_version")
  set(CMAKE_INSTALL_LIBEXECDIR ${CMAKE_INSTALL_LIBDIR})
  set(CMAKE_INSTALL_FULL_LIBEXECDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}")
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

# https://bugzilla.gnome.org/show_bug.cgi?id=669355
# Since gdbus-codegen does not produce warning-free code
# and we use -Werror, only enable these warnings for debug
# builds. Drop this once the issue has been fixed and landed.
if ("${cmake_build_type_lower}" STREQUAL debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wpedantic")# -Wextra")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wpedantic -Wextra")
endif()

if (${werror})
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
  set(CMAKE_C_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

pkg_check_modules(LOMIRI_APP_LAUNCH REQUIRED lomiri-app-launch-0>=0)
include_directories(${LOMIRI_APP_LAUNCH_INCLUDE_DIRS})

pkg_check_modules(GLIB2 REQUIRED glib-2.0)
include_directories(${GLIB2_INCLUDE_DIRS})

pkg_check_modules(GOBJECT2 REQUIRED gobject-2.0)
include_directories(${GOBJECT2_INCLUDE_DIRS})

pkg_check_modules(GIO2 REQUIRED gio-2.0)
include_directories(${GIO2_INCLUDE_DIRS})

pkg_check_modules(GIO_UNIX2 REQUIRED gio-unix-2.0)
include_directories(${GIO_UNIX2_INCLUDE_DIRS})

pkg_check_modules(JSONGLIB REQUIRED json-glib-1.0)
include_directories(${JSONGLIB_INCLUDE_DIRS})

pkg_check_modules(DBUSTEST REQUIRED dbustest-1>=14.04.0)
include_directories(${DBUSTEST_INCLUDE_DIRS})

pkg_check_modules(SQLITE REQUIRED sqlite3)
include_directories(${SQLITE_INCLUDE_DIRS})

pkg_check_modules(APPARMOR REQUIRED libapparmor)
include_directories(${APPARMOR_INCLUDE_DIRS})

if(${LOCAL_INSTALL})
  set(DBUSSERVICEDIR "${CMAKE_INSTALL_DATADIR}/dbus-1/services/")
else()
  EXEC_PROGRAM(${PKG_CONFIG_EXECUTABLE} ARGS dbus-1 --variable session_bus_services_dir OUTPUT_VARIABLE DBUSSERVICEDIR )
endif()
message("Installing DBus services to ${DBUSSERVICEDIR}")

if(${LOCAL_INSTALL})
  set(DBUSIFACEDIR "${CMAKE_INSTALL_DATADIR}/dbus-1/interfaces/")
else()
  EXEC_PROGRAM(${PKG_CONFIG_EXECUTABLE} ARGS dbus-1 --variable interfaces_dir OUTPUT_VARIABLE DBUSIFACEDIR )
endif()
message("Installing DBus interfaces to ${DBUSIFACEDIR}")

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11 -fPIC")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fPIC")

add_subdirectory(data)
add_subdirectory(service)
add_subdirectory(liblomiri-url-dispatcher)
add_subdirectory(tools)
add_subdirectory(gui)
add_subdirectory(po)
add_subdirectory(tests)

# coverage reporting
find_package(CoverageReport)
get_property(COVERAGE_TARGETS GLOBAL PROPERTY COVERAGE_TARGETS)
get_property(COVERAGE_TESTS GLOBAL PROPERTY COVERAGE_TESTS)
ENABLE_COVERAGE_REPORT(
  TARGETS ${COVERAGE_TARGETS}
  TESTS ${COVERAGE_TESTS}
  FILTER /usr/include ${CMAKE_BINARY_DIR}/*
)

=== data/CMakeLists.txt ===

###########################
# Set stuff
###########################

set(datadir "${CMAKE_INSTALL_FULL_DATADIR}")


###########################
# Dbus Interfaces
###########################

install(
FILES
com.lomiri.URLDispatcher.xml
DESTINATION ${DBUSIFACEDIR}
)

###########################
# QML
###########################

install(
FILES
bad-url.qml
DESTINATION ${datadir}/lomiri-url-dispatcher
)

=== gui/CMakeLists.txt ===

install(FILES
	lomiri-url-dispatcher-gui.qml
	lomiri-url-dispatcher-gui.svg
	DESTINATION "${CMAKE_INSTALL_DATADIR}/lomiri-url-dispatcher/gui/")
install(FILES
	${CMAKE_CURRENT_BINARY_DIR}/lomiri-url-dispatcher-gui.desktop
	DESTINATION "${CMAKE_INSTALL_DATADIR}/applications/")

configure_file(
	"lomiri-url-dispatcher-gui.desktop.in"
	"lomiri-url-dispatcher-gui.desktop"
	@ONLY)

=== service/CMakeLists.txt ===

include(UseConstantBuilder)
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_definitions( -DOVERLAY_SYSTEM_DIRECTORY="${CMAKE_INSTALL_FULL_DATADIR}/lomiri-url-dispatcher/url-overlays" )

###########################
# Generated Lib
###########################

add_gdbus_codegen(
  SERVICE_GENERATED
  service-iface
  com.lomiri.URLDispatcher.
  ${CMAKE_SOURCE_DIR}/data/com.lomiri.URLDispatcher.xml
  NAMESPACE ServiceIface
)

add_library(service-generated STATIC ${SERVICE_GENERATED_SOURCES})

target_link_libraries(service-generated
  ${GLIB2_LIBRARIES}
  ${GOBJECT2_LIBRARIES}
  ${GIO2_LIBRARIES}
)

###########################
# Dispatcher Lib
###########################

add_library(dispatcher-lib STATIC
	dispatcher.h
	dispatcher.c
	glib-thread.h
	glib-thread.cpp
	overlay-tracker.h
	overlay-tracker.cpp
	overlay-tracker-iface.h
	overlay-tracker-mir.h
	overlay-tracker-mir.cpp
)

target_link_libraries(dispatcher-lib
	url-db-lib
	service-generated
	-pthread
	${APPARMOR_LIBRARIES}
	${GLIB2_LIBRARIES}
	${GOBJECT2_LIBRARIES}
	${GIO2_LIBRARIES}
	${SQLITE_LIBRARIES}
	${LOMIRI_APP_LAUNCH_LIBRARIES}
)

###########################
# URL DB Lib
###########################

set(URL_DB_SOURCES
	url-db.c
	url-db.h
	create-db-sql.h
)

add_constant_template(URL_DB_SOURCES
	create-db-sql
	create_db_sql
	"${CMAKE_CURRENT_SOURCE_DIR}/create-db.sql"
)

add_library(url-db-lib STATIC
	${URL_DB_SOURCES}
)

target_link_libraries(url-db-lib
	${GLIB2_LIBRARIES}
	${SQLITE_LIBRARIES}
)

###########################
# Service Executable
###########################

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(service-exec service.cpp)

set_target_properties(service-exec PROPERTIES OUTPUT_NAME "lomiri-url-dispatcher")

target_link_libraries(service-exec dispatcher-lib)

###########################
# Update Directory
###########################

add_executable(update-directory update-directory.c)
set_target_properties(update-directory PROPERTIES OUTPUT_NAME "lomiri-update-directory")
target_link_libraries(update-directory ${GIO2_LIBRARIES} ${JSONGLIB_LIBRARIES} url-db-lib)

###########################
# Coverage
###########################
set_property(
  GLOBAL
  APPEND
  PROPERTY
  COVERAGE_TARGETS dispatcher-lib url-db-lib service-exec update-directory)

###########################
# Installation
###########################

install(
  TARGETS service-exec update-directory
  RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_LIBEXECDIR}/lomiri-url-dispatcher"
)

###########################
# Exec Tools
###########################

add_subdirectory(url-overlay)
add_subdirectory(bad-url)

=== tests/CMakeLists.txt ===
find_package(GMock)

set(APP_ID_TEST_URI 1)
configure_file(test-config.h.in test-config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

###########################
# Mock Lib
###########################

add_library(mock-lib STATIC
	apparmor-mock.h
	apparmor-mock.c
	lomiri-app-launch-mock.h
	lomiri-app-launch-mock.c)

target_link_libraries(mock-lib
	${GLIB2_LIBRARIES}
)

###########################
# Mir Mock Lib
###########################

add_library(mir-mock-lib SHARED
	mir-mock.h
	mir-mock.cpp)

target_link_libraries(mir-mock-lib
	-pthread
	${GLIB2_LIBRARIES}
)

set_target_properties(mir-mock-lib PROPERTIES
	OUTPUT_NAME "mir-mock"
)

###########################
# Dispatcher test
###########################

include_directories("${CMAKE_SOURCE_DIR}/service")

add_executable (dispatcher-test dispatcher-test.cc)
target_link_libraries (dispatcher-test
	dispatcher-lib
	mock-lib
	gtest
	${LOMIRI_APP_LAUNCH_LIBRARIES}
	${DBUSTEST_LIBRARIES}
	${GMOCK_LIBRARIES})

add_test (dispatcher-test dispatcher-test)

###########################
# lib test
###########################

add_executable (lib-test-no-main lib-test-no-main.c)
target_link_libraries (lib-test-no-main dispatcher)

add_executable (lib-test lib-test.cc)
target_link_libraries (lib-test
	dispatcher
	gtest
	${DBUSTEST_LIBRARIES}
	${GMOCK_LIBRARIES})

add_test (lib-test lib-test)

###########################
# service test
###########################

add_executable (service-test service-test.cc ${CMAKE_SOURCE_DIR}/service/glib-thread.cpp)
target_link_libraries (service-test
	url-db-lib
	-pthread
	dispatcher
	gtest
	${DBUSTEST_LIBRARIES}
	${LOMIRI_APP_LAUNCH_LIBRARIES}
	${GMOCK_LIBRARIES})

add_test (service-test service-test)


###########################
# create db test
###########################

add_test (NAME create-db-test
          COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/test-sql.sh" "${CMAKE_SOURCE_DIR}/service/create-db.sql")

###########################
# update directory test
###########################

add_executable (directory-update-test directory-update-test.cc)
target_link_libraries (directory-update-test
	url-db-lib
	gtest
	${GMOCK_LIBRARIES})

add_test (directory-update-test directory-update-test)

###########################
# url db test
###########################

add_executable (url-db-test url-db-test.cc)
target_link_libraries (url-db-test
	url-db-lib
	gtest
	${GMOCK_LIBRARIES})

add_test (url-db-test url-db-test)
add_subdirectory(url_dispatcher_testability)

###########################
# overlay tracker test
###########################

add_executable (overlay-tracker-test overlay-tracker-test.cpp)
target_link_libraries (overlay-tracker-test
	dispatcher-lib
	mir-mock-lib
	mock-lib
	gtest
	${GMOCK_LIBRARIES}
	${GIO2_LIBRARIES}
	${DBUSTEST_LIBRARIES})

add_test (overlay-tracker-test overlay-tracker-test)

###########################
# Coverage
###########################
set_property(
  GLOBAL
  APPEND
  PROPERTY COVERAGE_TESTS

  directory-update-test
  dispatcher-test
  exec-tool-test
  lib-test
  overlay-tracker-test
  service-test
  url-db-test
  )

=== service/bad-url/CMakeLists.txt ===
###########################
# Bad URL Exec Tool
###########################

add_definitions( -DQML_BAD_URL="${CMAKE_INSTALL_FULL_DATADIR}/url-dispatcher/bad-url.qml" )
add_executable(bad-url-exec-tool exec-tool.cpp)
set_target_properties(bad-url-exec-tool PROPERTIES OUTPUT_NAME "exec-tool")
target_link_libraries(bad-url-exec-tool ${GIO2_LIBRARIES} ${LOMIRI_APP_LAUNCH_LIBRARIES})

install(
  TARGETS bad-url-exec-tool
  RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_LIBEXECDIR}/lomiri-app-launch/bad-url"
)

=== debian/changelog ===
lomiri-url-dispatcher (0.1.0-4) unstable; urgency=medium

  * debian/rules:
    + Add dh_auto_test override. Run tests in --no-parallel mode.
  * debian/control:
    + Update versioned B-D on cmake-extras (>= 1.5-7~).
    + Drop alternative B-D on google-mock. B-D on googletest is sufficient these
      days.
    + Add B-D on libgtest-dev.
    + Bump Standards-Version: to 4.5.1. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 13 Dec 2020 16:03:30 +0100

lomiri-url-dispatcher (0.1.0-3) unstable; urgency=medium

  * debian/patches:
    + Add 1001_fix-runtime-error-fftbfs.patch. Add missing include of
      <stdexcept>. Fixes FTBFS against GCC-10.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 27 Sep 2020 16:10:28 +0200

lomiri-url-dispatcher (0.1.0-2) unstable; urgency=medium

  * debian/control:
    + Fix Vcs-*: URLs.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 07 Sep 2020 21:44:44 +0200

lomiri-url-dispatcher (0.1.0-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #961698).
  * Adapt for packaging Lomiri's fork of URL Dispatcher.
  * Adapt for uploading to Debian (instead of Ubuntu).

  * debian/control:
    + Bump DH compat level to version 13.
    + Drop full-stop from SYNOPSIS fields.
    + Drop ${python3:Depends} from D (lomiri-url-dispatcher-testability).
    + Update not-yet-available Ds and mark with FIXME.
  * debian/rules:
    + Add get-orig-source target.
    + Set hardening build flags.
  * debian/copyright:
    + Update URLs. Use secure proto.
    + Add auto-generated copyright.in file for tracking copyright changes.
    + Update copyright attributions.
  * debian/watch:
    + Add file.
  * lintian:
    + Override desktop-command-not-in-package for QML application.
    + Override binary-without-manpage (for now).

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 28 May 2020 08:40:36 +0200

url-dispatcher (0.2+ubports) bionic; urgency=medium

  * Imported to UBports

 -- UBports auto importer <infra@ubports.com>  Fri, 13 Oct 2017 19:54:36 +0200

url-dispatcher (0.1+17.04.20170328-0ubuntu1) zesty; urgency=medium

  * Fix deprecation warning in mir mock.
  * The unity8-dash interface is actually com.canonical.UnityDash.
  * Use libwhoopsie for reporting recoverable problems.
  * Convert service main process and url-dispatcher tool code to C++.

 -- Rodney Dawes <rodney.dawes@canonical.com>  Tue, 28 Mar 2017 18:29:07 +0000

url-dispatcher (0.1+17.04.20170318-0ubuntu1) zesty; urgency=medium

  * Update bad-url exec tool to UAL C++ interface
  * Remove Upstart from the test suite and replace it with systemd

 -- Ted Gould <ted@gould.cx>  Sat, 18 Mar 2017 19:59:26 +0000

url-dispatcher (0.1+17.04.20170314-0ubuntu1) zesty; urgency=medium

  [ Charles Kerr ]
  * Honor XDG_CACHE_HOME in url-dispatcher-dump and url-dispatcher.conf

  [ Rodney Dawes ]
  * Remove click usage and support.
  * Use gmock module from cmake-extras.
  * Use the coverage support from cmake-extras.
  * Use cmake-extras intltool support.
  * Use gdbus integration from cmake-extras.
  * Remove unused gsettings cmake module.

 -- Rodney Dawes <rodney.dawes@canonical.com>  Tue, 14 Mar 2017 14:35:03 +0000

url-dispatcher (0.1+17.04.20170308.1-0ubuntu1) zesty; urgency=medium

  * Don't use upstart to get unity8 pid.

 -- Rodney Dawes <rodney.dawes@canonical.com>  Wed, 08 Mar 2017 20:43:30 +0000

url-dispatcher (0.1+17.04.20170227.2-0ubuntu1) zesty; urgency=medium

  [ Ken VanDine ]
  * Handle UAL API bump

  [ Rodney Dawes ]
  * Remove tests that depend on libertine, as url-dispatcher has no
    support for handlers in libertine anyway.

 -- Rodney Dawes <rodney.dawes@canonical.com>  Mon, 27 Feb 2017 19:07:50 +0000

url-dispatcher (0.1+17.04.20161206-0ubuntu1) zesty; urgency=medium

  [ Ted Gould ]
  * Instead of sleeping make the refresh tasks low enough priority they
    don't get in the way (LP: #1645793)
  * Start after Unity8 so it has a chance to set the MIR_SOCKET

 -- Michael Terry <michael.terry@canonical.com>  Tue, 06 Dec 2016 14:38:17 +0000

url-dispatcher (0.1+17.04.20161108-0ubuntu1) zesty; urgency=medium

  * Support running inside a snap.

 -- Michael Terry <michael.terry@canonical.com>  Tue, 08 Nov 2016 22:16:56 +0000

url-dispatcher (0.1+17.04.20161107-0ubuntu1) zesty; urgency=medium

  [ Florian Boucault ]
  * Crossbuilding Fixes

  [ Larry Price ]
  * App ID should allow package names with dots. (LP: #1591342) (LP: #1606498)

  [ Ted Gould ]
  * Check versions of appid:// urls to reduce the number of invalid appids
    we send to UAL (LP: #1352656)
  * Scope testing for the scope:// URL and overlays that should be over
    the dash
  * Protect the dash from getting NULL urls (LP: #1476257)
  * Make sure URL Overlays are shutdown on exit
  * Remove the wildcard that is confusing the update script (LP: #1461496)
  * Not using a message that isn't set properly (LP: #1608009)
  * Fixing tests to adjust for UAL changes
  * Add a small GUI helper tool for testing
  * Show error dialog over apps that use Bad URLs (LP: #1370008)

 -- Ted Gould <ted@gould.cx>  Mon, 07 Nov 2016 16:33:15 +0000

url-dispatcher (0.1+16.10.20160816.1-0ubuntu1) yakkety; urgency=medium

  * No chnage rebuild for UAL migration

 -- Ted Gould <ted@gould.cx>  Tue, 16 Aug 2016 15:20:27 +0000

url-dispatcher (0.1+16.04.20151110-0ubuntu2) xenial; urgency=high

  * No change rebuild for s390x.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 11 Dec 2015 01:30:51 +0000

url-dispatcher (0.1+16.04.20151110-0ubuntu1) xenial; urgency=medium

  [ CI Train Bot ]
  * New rebuild forced.

  [ Ted Gould ]
  * Remove the cache if the service fails to start. Fail to start if we
    can't create the database. (LP: #1483854)

 -- Bill Filler <ci-train-bot@canonical.com>  Tue, 10 Nov 2015 14:37:07 +0000

url-dispatcher (0.1+15.10.20150717-0ubuntu1) wily; urgency=medium

  [ Andreas Pokorny ]
  * unchagned for mir release 0.14.0

 -- CI Train Bot <ci-train-bot@canonical.com>  Fri, 17 Jul 2015 12:37:44 +0000



=== debian/control ===
Source: lomiri-url-dispatcher
Section: gnome
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               cmake-extras (>= 1.5-7~),
               dbus-test-runner,
               debhelper-compat (= 13),
               dh-apparmor,
               dh-python,
               gcovr,
               googletest,
               intltool,
               lcov,
               libapparmor-dev,
               libdbus-1-dev,
               libdbustest1-dev (>= 14.04.0),
               libglib2.0-dev,
               libgtest-dev,
               libjson-glib-dev,
               libsqlite3-dev,
               liblomiri-app-launch-dev (>= 0.0.90),
               python3,
               python3-dbusmock,
               python3-fixtures,
               python3-nose,
               python3-testtools,
               sqlite3,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/core/lomiri-url-dispatcher
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-url-dispatcher.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-url-dispatcher/

Package: lomiri-url-dispatcher
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
# For the bad URL dialog
         qtchooser,
# FIXME: qml-lomiri-ui-toolkit-plugin,
Description: Lomiri Operating Environment service for requesting URLs to be opened
 Allows applications to request a URL to be opened and handled by another
 process without seeing the list of other applications on the system or
 starting them inside its own Application Confinement.
 .
 This package provides a service for the Lomiri URL Dispatcher

Package: lomiri-url-dispatcher-tools
Architecture: any
Depends: lomiri-url-dispatcher (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Tools for working with the Lomiri URL Dispatcher
 Allows applications to request a URL to be opened and handled by another
 process without seeing the list of other applications on the system or
 starting them inside its own Application Confinement.
 .
 This package provides tools for working with the Lomiri URL Dispatcher.

Package: lomiri-url-dispatcher-tools-gui
Architecture: any
Depends: lomiri-url-dispatcher (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         qtchooser,
# FIXME: qml-module-ubuntu-components-labs,
Description: GUI tools for working with the Lomiri URL Dispatcher
 Allows applications to request a URL to be opened and handled by another
 process without seeing the list of other applications on the system or
 starting them inside its own Application Confinement.
 .
 This package provides GUI tools for working with the Lomiri URL Dispatcher.

Package: liblomiri-url-dispatcher0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Suggests: lomiri-url-dispatcher (= ${binary:Version}),
Description: Library for sending requests to the Lomiri URL Dispatcher
 Allows applications to request a URL to be opened and handled by another
 process without seeing the list of other applications on the system or
 starting them inside its own Application Confinement.
 .
 This package contains shared libraries to be used by applications.

Package: liblomiri-url-dispatcher-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: libglib2.0-dev,
         liblomiri-url-dispatcher0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Development files for consumers of the Lomiri URL Dispatcher
 Allows applications to request a URL to be opened and handled by another
 process without seeing the list of other applications on the system or
 starting them inside its own Application Confinement.
 .
 This package contains files that are needed to build applications.

Package: lomiri-url-dispatcher-testability
Architecture: all
Depends: ${misc:Depends},
         python3,
         python3-dbusmock,
         python3-dbus,
Description: Fake Lomiri URL Dispatcher for use in testing
 Allows applications to request a URL to be opened and handled by another
 process without seeing the list of other applications on the system or
 starting them inside its own Application Confinement.
 .
 This package contains a fake Lomiri URL Dispatcher for use in testing.

=== debian/rules ===
#!/usr/bin/make -f

export DPKG_GENSYMBOLS_CHECK_LEVEL = 4
export G_MESSAGES_DEBUG=all
export URL_DISPATCHER_DISABLE_RECOVERABLE_ERROR=1
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
export DEB_BUILD_PROFILES := cross
endif

include /usr/share/dpkg/buildflags.mk
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=debug

override_dh_missing:
	dh_missing --fail-missing

override_dh_apparmor:
	dh_apparmor --profile-name=lomiri-url-dispatcher-bad-url-helper -p lomiri-url-dispatcher

override_dh_auto_test:
	dh_auto_test --no-parallel

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
https://gitlab.com/ubports/core/lomiri-url-dispatcher/tags .*/lomiri-url-dispatcher-(\d\S+)\.tar\.gz

## lomiri-url-dispatcher 0.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 project(lomiri-url-dispatcher C CXX)
-cmake_minimum_required(VERSION 2.8.9)
+cmake_minimum_required(VERSION 3.4)
 
 string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lowercase but sometimes they are not.
 
@@ -11,6 +11,7 @@
 
 enable_testing ()
 option (enable_lcov "Generate Coverage Reports" ON)
+option (enable_mirclient "Enable overlay using mirclient" ON)
 
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")
 
@@ -89,6 +90,9 @@
 endif()
 message("Installing DBus interfaces to ${DBUSIFACEDIR}")
 
+pkg_check_modules(SYSTEMD REQUIRED systemd)
+pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
+
 include_directories(${CMAKE_CURRENT_SOURCE_DIR})
 include_directories(${CMAKE_CURRENT_BINARY_DIR})

=== debian/changelog ===
lomiri-url-dispatcher (0.1.1-2) unstable; urgency=medium

  * Bump lomiri-app-launch version requirement
  * Add patch to build aganst lomiri-app-launch without mirclient

 -- Marius Gripsgard <marius@ubports.com>  Wed, 04 Jan 2023 15:18:45 +0100

lomiri-url-dispatcher (0.1.1-1) unstable; urgency=medium

  * [debian/control] Add myself as uploader
  * [debian/copyright] Refresh copyright to match new release
  * [debian/control] Add systemd as B-D
  * [debian/control] Renable lomiri-ui-tookit deps
  * [debian/.install] Update install to match upstream
  * [debian/rules] Disable use mirclient
  * [debian/patches] Drop upstreamed patches:
    - 0001_Fix-compile-error-with-new-glib-versions.patch
    - 0002_Fix-generic-URL-regex.patch
    - 0003_gui-lomiri-url-dispatcher-gui.desktop.in-Add-Keyword.patch
    - 0004_gcc-12-fix.patch
    - 1001_fix-runtime-error-fftbfs.patch

 -- Marius Gripsgard <marius@ubports.com>  Tue, 03 Jan 2023 09:54:48 +0100

lomiri-url-dispatcher (0.1.0-8) unstable; urgency=medium

  * debian/:
    + Update upstream Git repo URL.
  * debian/patches:
    + Add 0004_gcc-12-fix.patch. (Closes: #1016254).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 30 Sep 2022 23:51:42 +0200

lomiri-url-dispatcher (0.1.0-7) unstable; urgency=medium

  * Upload as-is source-only.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 26 Feb 2022 22:50:42 +0100

lomiri-url-dispatcher (0.1.0-6) unstable; urgency=medium

  * debian/patches:
    + Add 1002_adjust-to-sqlite3-upper-case-types.patch. Test for built-in types
      case-insensitively. Due to behaviour change in sqlite 3.37.x. (Closes:
      #1005608).
  * debian/control:
    + Bump Standards-Version: to 4.6.0. No changes needed.
  * debian/*.lintian-overrides:
    + Rename lintian tag binary-without-manpage to no-manual-page.
  * debian/patches:
    + Add 0003_gui-lomiri-url-dispatcher-gui.desktop.in-Add-Keyword.patch. Add
      Keywords= key to .desktop file.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 14 Feb 2022 13:38:18 +0100

lomiri-url-dispatcher (0.1.0-5) unstable; urgency=medium

  * debian/patches:
    + Add 0001_Fix-compile-error-with-new-glib-versions.patch. Fix FTBFS
      against latest GLib-2.0. Thanks to Luca Weiss. (Closes: #997237).
  * debian/patches:
    + Add 0002_Fix-generic-URL-regex.patch. Fix generic URL regexp. Thanks to
      Hatato.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 08 Nov 2021 18:09:17 +0100

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
+ Marius Gripsgard <marius@ubports.com>,
 Build-Depends: cmake,
                cmake-extras (>= 1.5-7~),
                dbus-test-runner,
@@ -21,16 +22,17 @@
                libgtest-dev,
                libjson-glib-dev,
                libsqlite3-dev,
-               liblomiri-app-launch-dev (>= 0.0.90),
+               liblomiri-app-launch-dev (>= 0.1.2-2),
                python3,
                python3-dbusmock,
                python3-fixtures,
                python3-nose,
                python3-testtools,
                sqlite3,
-Standards-Version: 4.5.1
+               systemd,
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
-Homepage: https://gitlab.com/ubports/core/lomiri-url-dispatcher
+Homepage: https://gitlab.com/ubports/development/core/lomiri-url-dispatcher
 Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-url-dispatcher.git
 Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-url-dispatcher/
 
@@ -42,7 +44,7 @@
          ${shlibs:Depends},
 # For the bad URL dialog
          qtchooser,
-# FIXME: qml-lomiri-ui-toolkit-plugin,
+         qml-module-lomiri-components
 Description: Lomiri Operating Environment service for requesting URLs to be opened
  Allows applications to request a URL to be opened and handled by another
  process without seeing the list of other applications on the system or
@@ -68,7 +70,7 @@
          ${misc:Depends},
          ${shlibs:Depends},
          qtchooser,
-# FIXME: qml-module-ubuntu-components-labs,
+         qml-module-lomiri-components-labs,
 Description: GUI tools for working with the Lomiri URL Dispatcher
  Allows applications to request a URL to be opened and handled by another
  process without seeing the list of other applications on the system or

## lomiri-url-dispatcher 0.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
-project(lomiri-url-dispatcher C CXX)
-cmake_minimum_required(VERSION 3.4)
+cmake_minimum_required(VERSION 3.5)
+project(lomiri-url-dispatcher VERSION 0.1.2 LANGUAGES C CXX)
 
 string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lowercase but sometimes they are not.
 
@@ -17,6 +17,7 @@
 
 set(PACKAGE ${CMAKE_PROJECT_NAME})
 set(GETTEXT_PACKAGE ${CMAKE_PROJECT_NAME})
+set(DESKTOP_FILE ${PROJECT_NAME}-gui.desktop)
 
 find_package(PkgConfig REQUIRED)
 find_package(GDbus)
@@ -49,7 +50,7 @@
   set(CMAKE_C_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
 endif()
 
-pkg_check_modules(LOMIRI_APP_LAUNCH REQUIRED lomiri-app-launch-0>=0)
+pkg_check_modules(LOMIRI_APP_LAUNCH REQUIRED lomiri-app-launch-0>=0.1.3)
 include_directories(${LOMIRI_APP_LAUNCH_INCLUDE_DIRS})
 
 pkg_check_modules(GLIB2 REQUIRED glib-2.0)

=== data/CMakeLists.txt ===

###########################
# Set stuff
###########################

set(pkglibexecdir "${CMAKE_INSTALL_FULL_LIBEXECDIR}/lomiri-url-dispatcher")
set(datadir "${CMAKE_INSTALL_FULL_DATADIR}")

###########################
# DBus Interfaces, Service
###########################

configure_file(
com.lomiri.URLDispatcher.service.in
${CMAKE_CURRENT_BINARY_DIR}/com.lomiri.URLDispatcher.service
)

install(
FILES
${CMAKE_CURRENT_BINARY_DIR}/com.lomiri.URLDispatcher.service
DESTINATION ${DBUSSERVICEDIR}
)

install(
FILES
com.lomiri.URLDispatcher.xml
DESTINATION ${DBUSIFACEDIR}
)

###########################
# systemd
###########################

configure_file(
lomiri-url-dispatcher.service.in
${CMAKE_CURRENT_BINARY_DIR}/lomiri-url-dispatcher.service
)

configure_file(
lomiri-url-dispatcher-update-system-dir.path.in
${CMAKE_CURRENT_BINARY_DIR}/lomiri-url-dispatcher-update-system-dir.path
)

configure_file(
lomiri-url-dispatcher-update-system-dir.service.in
${CMAKE_CURRENT_BINARY_DIR}/lomiri-url-dispatcher-update-system-dir.service
)

configure_file(
lomiri-url-dispatcher-update-user-dir.path.in
${CMAKE_CURRENT_BINARY_DIR}/lomiri-url-dispatcher-update-user-dir.path
)

configure_file(
lomiri-url-dispatcher-update-user-dir.service.in
${CMAKE_CURRENT_BINARY_DIR}/lomiri-url-dispatcher-update-user-dir.service
)

install(
FILES
${CMAKE_CURRENT_BINARY_DIR}/lomiri-url-dispatcher.service
${CMAKE_CURRENT_BINARY_DIR}/lomiri-url-dispatcher-update-system-dir.path
${CMAKE_CURRENT_BINARY_DIR}/lomiri-url-dispatcher-update-system-dir.service
${CMAKE_CURRENT_BINARY_DIR}/lomiri-url-dispatcher-update-user-dir.path
${CMAKE_CURRENT_BINARY_DIR}/lomiri-url-dispatcher-update-user-dir.service
DESTINATION ${SYSTEMD_USER_UNIT_DIR}
)

###########################
# Click Hook
###########################

configure_file("lomiri-url-dispatcher.hook.in"
	"${CMAKE_SOURCE_DIR}/debian/lomiri-url-dispatcher.hook"
	@ONLY
)

###########################
# QML
###########################

install(
FILES
bad-url.qml
DESTINATION ${datadir}/lomiri-url-dispatcher
)

=== gui/CMakeLists.txt ===
include(FindGettext)

install(FILES
	lomiri-url-dispatcher-gui.qml
	lomiri-url-dispatcher-gui.svg
	DESTINATION "${CMAKE_INSTALL_DATADIR}/lomiri-url-dispatcher/gui/")
install(FILES
	${CMAKE_CURRENT_BINARY_DIR}/lomiri-url-dispatcher-gui.desktop
	DESTINATION "${CMAKE_INSTALL_DATADIR}/applications/")

configure_file(${DESKTOP_FILE}.in.in ${DESKTOP_FILE}.in)
add_custom_target(${DESKTOP_FILE} ALL
    COMMENT "Merging translations into ${DESKTOP_FILE}..."
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
            --desktop --template=${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}.in
            -o ${DESKTOP_FILE}
            -d ${CMAKE_SOURCE_DIR}/po
)

=== liblomiri-url-dispatcher/CMakeLists.txt ===

###########################
# Version Information
###########################

set(API_VERSION 0)
set(ABI_VERSION 0)

###########################
# Lib
###########################

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(DISPATCHER_HEADERS
lomiri-url-dispatcher.h
)

set(DISPATCHER_SOURCES
lomiri-url-dispatcher.c
)

add_library(dispatcher SHARED ${DISPATCHER_SOURCES})

set_target_properties(dispatcher PROPERTIES
  VERSION ${API_VERSION}.0.0
  SOVERSION ${ABI_VERSION}
  OUTPUT_NAME "lomiri-url-dispatcher"
)

target_link_libraries(dispatcher
service-generated
${GLIB2_LIBRARIES}
${GOBJECT2_LIBRARIES}
-Wl,--no-undefined
)

###########################
# Coverage
###########################
set_property(GLOBAL APPEND PROPERTY COVERAGE_TARGETS dispatcher)

###########################
# Pkg Config
###########################

set(DISPATCHER_PC "lomiri-url-dispatcher.pc")
set(apiversion "${API_VERSION}")
set(libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
set(VERSION "${ABI_VERSION}")

configure_file("lomiri-url-dispatcher.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/${DISPATCHER_PC}" @ONLY)

###########################
# Installation
###########################

install(
  FILES ${DISPATCHER_HEADERS}
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/liblomiri-url-dispatcher"
)

install(
  FILES "${CMAKE_CURRENT_BINARY_DIR}/${DISPATCHER_PC}"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

install(
  TARGETS dispatcher
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== service/CMakeLists.txt ===
--- 
+++ 
@@ -28,6 +28,14 @@
 # Dispatcher Lib
 ###########################
 
+if(enable_mirclient)
+  set(OVERLAY_MIR_SOURCES
+	overlay-tracker-mir.h
+	overlay-tracker-mir.cpp
+  )
+  add_definitions(-DUSE_MIRCLIENT=1)
+endif()
+
 add_library(dispatcher-lib STATIC
 	dispatcher.h
 	dispatcher.c
@@ -36,8 +44,7 @@
 	overlay-tracker.h
 	overlay-tracker.cpp
 	overlay-tracker-iface.h
-	overlay-tracker-mir.h
-	overlay-tracker-mir.cpp
+	${OVERLAY_MIR_SOURCES}
 )
 
 target_link_libraries(dispatcher-lib

=== debian/changelog ===
lomiri-url-dispatcher (0.1.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump versioned B-D to lomiri-app-launch-dev (>= 0.1.3).
    + Bump Standards-Version: to 4.6.2. No changes needed.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * lintian: Adjust overrides to new syntax.
  * debian/patches:
    + Improve 1002_adjust-to-sqlite3-upper-case-types.patch as suggested by
      Ratchanan Srirattanamet.
  * debian/lomiri-url-dispatcher.install:
    + Include locale files. This needs to be moved into separate common:pkg
      in the bookworm+1 cycle.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 05 Feb 2023 02:04:01 +0100

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
                libgtest-dev,
                libjson-glib-dev,
                libsqlite3-dev,
-               liblomiri-app-launch-dev (>= 0.1.2-2),
+               liblomiri-app-launch-dev (>= 0.1.3),
                python3,
                python3-dbusmock,
                python3-fixtures,
@@ -30,7 +30,7 @@
                python3-testtools,
                sqlite3,
                systemd,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/lomiri-url-dispatcher
 Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-url-dispatcher.git

## lomiri-url-dispatcher 0.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-url-dispatcher VERSION 0.1.2 LANGUAGES C CXX)
+project(lomiri-url-dispatcher VERSION 0.1.3 LANGUAGES C CXX)
 
 string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lowercase but sometimes they are not.
 
@@ -98,7 +98,7 @@
 include_directories(${CMAKE_CURRENT_BINARY_DIR})
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11 -fPIC")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fPIC")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -fPIC")
 
 add_subdirectory(data)
 add_subdirectory(service)

=== debian/changelog ===
lomiri-url-dispatcher (0.1.3-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository.
  * Remove unnecessary get-orig-source-target.

  [ Mike Gabriel ]
  * Revert "Remove unnecessary get-orig-source-target."

  [ Marius Gripsgard ]
  * New upstream release (closes: 1041120)
  * debian/control: Change my email to debian.org

 -- Marius Gripsgard <mariogrip@debian.org>  Wed, 26 Jul 2023 03:54:00 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
- Marius Gripsgard <marius@ubports.com>,
+ Marius Gripsgard <mariogrip@debian.org>,
 Build-Depends: cmake,
                cmake-extras (>= 1.5-7~),
                dbus-test-runner,
@@ -17,7 +17,7 @@
                lcov,
                libapparmor-dev,
                libdbus-1-dev,
-               libdbustest1-dev (>= 14.04.0),
+               libdbustest1-dev,
                libglib2.0-dev,
                libgtest-dev,
                libjson-glib-dev,

=== debian/watch ===
version=4
https://gitlab.com/ubports/development/core/lomiri-url-dispatcher/tags .*/lomiri-url-dispatcher-(\d\S+)\.tar\.gz

## lomiri-url-dispatcher 0.1.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-url-dispatcher VERSION 0.1.3 LANGUAGES C CXX)
+project(lomiri-url-dispatcher VERSION 0.1.4 LANGUAGES C CXX)
 
 string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lowercase but sometimes they are not.
 
@@ -50,7 +50,7 @@
   set(CMAKE_C_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
 endif()
 
-pkg_check_modules(LOMIRI_APP_LAUNCH REQUIRED lomiri-app-launch-0>=0.1.3)
+pkg_check_modules(LOMIRI_APP_LAUNCH REQUIRED lomiri-app-launch-0>=0.1.4)
 include_directories(${LOMIRI_APP_LAUNCH_INCLUDE_DIRS})
 
 pkg_check_modules(GLIB2 REQUIRED glib-2.0)
@@ -76,6 +76,11 @@
 
 pkg_check_modules(APPARMOR REQUIRED libapparmor)
 include_directories(${APPARMOR_INCLUDE_DIRS})
+
+if(enable_mirclient)
+  pkg_search_module(MIR REQUIRED mir1client mirclient)
+  include_directories(${MIR_INCLUDE_DIRS})
+endif()
 
 if(${LOCAL_INSTALL})
   set(DBUSSERVICEDIR "${CMAKE_INSTALL_DATADIR}/dbus-1/services/")

=== gui/CMakeLists.txt ===
--- 
+++ 
@@ -16,3 +16,8 @@
             -o ${DESKTOP_FILE}
             -d ${CMAKE_SOURCE_DIR}/po
 )
+
+configure_file(lomiri-url-dispatcher-gui.in lomiri-url-dispatcher-gui @ONLY)
+install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/lomiri-url-dispatcher-gui
+  DESTINATION ${CMAKE_INSTALL_BINDIR}
+)

=== po/CMakeLists.txt ===
include(FindGettext)

find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)
if("${GETTEXT_XGETTEXT_EXECUTABLE}" STREQUAL "GETTEXT_XGETTEXT_EXECUTABLE-NOTFOUND")
    message(FATAL_ERROR "Could not find xgettext")
endif()

set(DOMAIN ${PROJECT_NAME})
set(POT_FILE ${DOMAIN}.pot)

file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/LINGUAS LINGUAS
     REGEX "^[^#].*")
string(REGEX MATCHALL "[^ \t]+" LANGS "${LINGUAS}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/POTFILES.in
               ${CMAKE_CURRENT_BINARY_DIR}/POTFILES COPYONLY)

add_custom_target(${POT_FILE} ALL
                  COMMENT "Generating translation template"
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          --from-code=UTF-8
                          --language=Desktop
                          --package-name='${PROJECT_NAME}'
                          --copyright-holder='Canonical Ltd.'
                          -D ${CMAKE_BINARY_DIR}
                          gui/${DESKTOP_FILE}.in
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          -D ${CMAKE_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_BINARY_DIR}
                          --from-code=UTF-8
                          --c++
                          --qt
                          --add-comments=TRANSLATORS
                          --keyword=_ --keyword=tr --keyword=tr:1,2
                          --package-name='${PROJECT_NAME}'
                          --copyright-holder='Canonical Ltd.'
                          --join-existing --files-from=${CMAKE_CURRENT_BINARY_DIR}/POTFILES)

foreach(LANG ${LANGS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${LANG}.po
                   ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.po
                   COPYONLY)
endforeach(LANG)
gettext_process_pot_file(${POT_FILE} ALL
                         INSTALL_DESTINATION ${CMAKE_INSTALL_LOCALEDIR}
                         LANGUAGES ${LANGS})

=== service/CMakeLists.txt ===
--- 
+++ 
@@ -58,6 +58,12 @@
 	${SQLITE_LIBRARIES}
 	${LOMIRI_APP_LAUNCH_LIBRARIES}
 )
+
+if(enable_mirclient)
+  target_link_libraries(dispatcher-lib
+	${MIR_LIBRARIES}
+  )
+endif()
 
 ###########################
 # URL DB Lib

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -22,18 +22,22 @@
 # Mir Mock Lib
 ###########################
 
-add_library(mir-mock-lib SHARED
+if(enable_mirclient)
+  add_library(mir-mock-lib SHARED
 	mir-mock.h
 	mir-mock.cpp)
 
-target_link_libraries(mir-mock-lib
+  target_link_libraries(mir-mock-lib
 	-pthread
 	${GLIB2_LIBRARIES}
-)
+  )
 
-set_target_properties(mir-mock-lib PROPERTIES
-	OUTPUT_NAME "mir-mock"
-)
+  set_target_properties(mir-mock-lib PROPERTIES
+  	OUTPUT_NAME "mir-mock"
+  )
+
+  add_definitions(-DUSE_MIRCLIENT=1)
+endif()
 
 ###########################
 # Dispatcher test
@@ -121,8 +125,9 @@
 # overlay tracker test
 ###########################
 
-add_executable (overlay-tracker-test overlay-tracker-test.cpp)
-target_link_libraries (overlay-tracker-test
+if(enable_mirclient)
+  add_executable (overlay-tracker-test overlay-tracker-test.cpp)
+  target_link_libraries (overlay-tracker-test
 	dispatcher-lib
 	mir-mock-lib
 	mock-lib
@@ -131,7 +136,8 @@
 	${GIO2_LIBRARIES}
 	${DBUSTEST_LIBRARIES})
 
-add_test (overlay-tracker-test overlay-tracker-test)
+  add_test (overlay-tracker-test overlay-tracker-test)
+endif()
 
 ###########################
 # Coverage

=== tools/CMakeLists.txt ===

###########################
# URL Dispatcher
###########################

include_directories(${CMAKE_SOURCE_DIR}/liblomiri-url-dispatcher)

add_executable(lomiri-url-dispatcher url-dispatcher.cpp)

target_link_libraries(lomiri-url-dispatcher
  dispatcher
)

install(
  TARGETS lomiri-url-dispatcher
  RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
)

install(
  PROGRAMS lomiri-url-dispatcher-dump
  DESTINATION "${CMAKE_INSTALL_BINDIR}"
)

##########################
# Coverage
###########################
set_property(GLOBAL APPEND PROPERTY COVERAGE_TARGETS lomiri-url-dispatcher)

=== service/url-overlay/CMakeLists.txt ===

###########################
# URL Overlay Exec Tool
###########################

add_executable(url-overlay-exec-tool exec-tool.c)
set_target_properties(url-overlay-exec-tool PROPERTIES OUTPUT_NAME "exec-tool")
target_link_libraries(url-overlay-exec-tool ${GIO2_LIBRARIES} ${LOMIRI_APP_LAUNCH_LIBRARIES})

install(
  TARGETS url-overlay-exec-tool
  RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_LIBEXECDIR}/lomiri-app-launch/url-overlay"
)

=== tests/url_dispatcher_testability/CMakeLists.txt ===
execute_process(COMMAND python3 -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())"
    OUTPUT_VARIABLE PYTHON_PACKAGE_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)

configure_file(
  test_fake_dispatcher.py.in
  test_fake_dispatcher.py
  )

### FIXME: omitting test_fake_dispatcher.py (see below), it contains build time path assumptions
install(FILES fixture_setup.py fake_dispatcher.py
    DESTINATION ${PYTHON_PACKAGE_DIR}/lomiri_url_dispatcher_testability
)

#install(FILES fixture_setup.py fake_dispatcher.py ${CMAKE_CURRENT_BINARY_DIR}/test_fake_dispatcher.py
#    DESTINATION ${PYTHON_PACKAGE_DIR}/lomiri_url_dispatcher_testability
#)

### FIXME: This test requires to use a systemd user session on the Dbus. We don't have that at build time.

#add_test(fake-dispatcher dbus-test-runner --task nosetests3 --parameter ${CMAKE_CURRENT_BINARY_DIR}/test_fake_dispatcher.py)
#set_tests_properties(fake-dispatcher PROPERTIES ENVIRONMENT PYTHONPATH=${CMAKE_CURRENT_SOURCE_DIR}/..)

=== debian/changelog ===
lomiri-url-dispatcher (0.1.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/patches:
    + Drop 1002_adjust-to-sqlite3-upper-case-types.patch. Applied upstream.
  * debian/lomiri-url-dispatcher-tools-gui.install:
    + Add /usr/bin/lomiri-url-dispatcher-gui.
  * debian/copyright:
    + Update copyright attributions.
  * debian/lomiri-url-dispatcher-tools-gui.lintian-overrides:
    + Drop file. Not needed anymore.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 05 May 2025 11:20:17 +0200

lomiri-url-dispatcher (0.1.3-3) unstable; urgency=medium

  * debian/control:
    + Drop from B-D: python3-nose. The test using nosetests3 is currently
      disabled, thus python3-nose is not needed at build time. (Closes:
      #1018404).
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 14 Aug 2024 18:49:19 +0200

lomiri-url-dispatcher (0.1.3-2) unstable; urgency=medium

  * debian/control:
    + Replace systemd by systemd-dev in B-D. (Closes: #1060544).
    + Bump Standards-Version to 4.7.0. No changes needed.
  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 14 May 2024 16:30:58 +0200

=== debian/control ===
--- 
+++ 
@@ -26,11 +26,10 @@
                python3,
                python3-dbusmock,
                python3-fixtures,
-               python3-nose,
                python3-testtools,
                sqlite3,
-               systemd,
-Standards-Version: 4.6.2
+               systemd-dev [linux-any],
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/lomiri-url-dispatcher
 Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-url-dispatcher.git

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_BUILD_TYPE=debug
+	dh_auto_configure -- -DCMAKE_BUILD_TYPE=debug -Denable_mirclient=off
 
 override_dh_missing:
 	dh_missing --fail-missing
